#ifdef MYPOPEN
/* @(#)popen.c	4.4 (Berkeley) 9/25/83 */
#include <stdio.h>
#include <signal.h>
#include <sys/wait.h>
#include <sys/time.h>
#include <sys/resource.h>

#define	tst(a,b)	(*mode == 'r'? (b) : (a))
#define	RDR	0
#define	WTR	1
static int      popen_pid[20];

#ifdef USE_SYS_PROTOS
#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

extern int                    pipe P_((int *));
extern pid_t                  fork P_((void));
extern int                    close P_((int));
extern int                    dup2 P_((int, int));
extern int                    execl P_((const char *, const char *, ...));
extern int                    fclose P_((FILE *));
extern pid_t                  waitpid P_((pid_t, int *, int));

#undef P_
#endif

FILE           *
mypopen(cmd, cmds, mode)
   char           *cmd, *cmds;
   char           *mode;
{
   int             p[2];
   register        myside, hisside, pid;

   if (pipe(p) < 0)
      return NULL;
   myside = tst(p[WTR], p[RDR]);
   hisside = tst(p[RDR], p[WTR]);
   if ((pid = fork()) == 0) {
      /* myside and hisside reverse roles in child */
      close(myside);
      if (hisside != tst(0, 1)) {
	 dup2(hisside, tst(0, 1));
	 close(hisside);
      }
      execl(cmd, cmds, 0);	/* only difference */
      _exit(1);
   }
   if (pid == -1) {
      close(myside);
      close(hisside);
      return NULL;
   }
   popen_pid[myside] = pid;
   close(hisside);
   return (fdopen(myside, mode));
}

int
mypclose(ptr)
   FILE           *ptr;
{
   register        f, r;
   register void   (*hstat) (), (*istat) (), (*qstat) ();
   int             status;

   f = fileno(ptr);
   fclose(ptr);
   istat = signal(SIGINT, SIG_IGN);
   qstat = signal(SIGQUIT, SIG_IGN);
   hstat = signal(SIGHUP, SIG_IGN);
   /*
    * waits on wrong child while((r = wait(&status)) != popen_pid[f] && r !=
    * -1) ;
    */
   r = waitpid(popen_pid[f], &status, 0);

   if (r == -1)
      status = -1;
   signal(SIGINT, istat);
   signal(SIGQUIT, qstat);
   signal(SIGHUP, hstat);
   return (status);
}
#endif
